using System;
using System.Collections;
using System.ComponentModel;
using System.Configuration.Install;
using System.Diagnostics;
using System.ServiceProcess;

namespace IBMKeyManagement {
	[RunInstaller(true)]
	public class HostInstaller : System.Configuration.Install.Installer {
		private ServiceInstaller serviceInstaller;
		private ServiceProcessInstaller processInstaller;

		public HostInstaller() {
			// Instantiate installers for process and services.
			processInstaller = new ServiceProcessInstaller();
			serviceInstaller = new ServiceInstaller();

			// The services run under the system account.
			processInstaller.Account = ServiceAccount.LocalSystem;

			// The services are started manually.
			serviceInstaller.StartType = ServiceStartMode.Manual;

			// ServiceName must equal those on ServiceBase derived classes.            
			serviceInstaller.ServiceName = HostService.SERVICE_NAME;

			// Add installers to collection. Order is not important.
			Installers.Add(serviceInstaller);
			Installers.Add(processInstaller);
		}

		public override void Install(IDictionary stateSaver) {
			base.Install(stateSaver);
			Process.Start("InstallUtil", Context.Parameters["path"]);
		}

		public override void Uninstall(IDictionary savedState) {
			Process.Start("InstallUtil",  "/u " + Context.Parameters["path"]);
			base.Uninstall(savedState);
		}
	}
}
